> For the complete documentation index, see [llms.txt](https://mariadb.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://mariadb.com/docs/analytics/mariadb-columnstore/reference/data-manipulation-statements/columnstore-delete.md).

# ColumnStore DELETE

The `DELETE` statement is used to remove rows from tables.

## Syntax

```bnf
DELETE 
 [FROM] tbl_name 
    [WHERE where_condition]
    [ORDER BY ...]
    [LIMIT row_count]
```

No disk space is recovered after a `DELETE`. `TRUNCATE` and `DROP PARTITION` can be used to recover space, or `CREATE TABLE`, loading only the remaining rows, then using DROP TABLE on the original table and `RENAME TABLE`.

`LIMIT` will limit the number of rows deleted, which will perform the `DELETE` more quickly. The `DELETE ... LIMIT` statement can then be performed multiple times to achieve the same effect as `DELETE` with no `LIMIT`.

The following statement deletes customer records with a customer key identification between 1001 and 1999:

```sql
DELETE FROM customer 
  WHERE custkey > 1000 AND custkey <2000
```

<sub>*This page is: Copyright © 2025 MariaDB. All rights reserved.*</sub>

{% @marketo/form formId="4316" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://mariadb.com/docs/analytics/mariadb-columnstore/reference/data-manipulation-statements/columnstore-delete.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
